install 25 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios
  21. type="ERROR"
  22. exitNum=$1
  23. codeNum=$2
  24. extraInfo=$3
  25. case $codeNum in
  26. 1)
  27. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  28. ;;
  29. 2)
  30. error="$type $codeNum:\tError interno (selección express).\n"
  31. ;;
  32. 3)
  33. error="$type $codeNum:\tError interno (selección avanzada).\n"
  34. ;;
  35. 100)
  36. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  37. ;;
  38. 101)
  39. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  40. ;;
  41. 102)
  42. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  43. ;;
  44. 103)
  45. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  46. ;;
  47. 104)
  48. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  49. ;;
  50. 105)
  51. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  52. ;;
  53. 200)
  54. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  55. ;;
  56. 201)
  57. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 202)
  60. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  61. ;;
  62. 203)
  63. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  64. ;;
  65. 204)
  66. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  67. ;;
  68. 205)
  69. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  70. ;;
  71. 206)
  72. type="WARNING"
  73. error="$type $codeNum:\tUsuario 'root' ya dispone de contraseña.\n"
  74. ;;
  75. 207)
  76. error="$type $codeNum:\tImposible cambiar la contraseña de 'root'.\n"
  77. ;;
  78. 208)
  79. error="$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior.\n"
  80. ;;
  81. 209)
  82. error="$type $codeNum:\tImposible eliminar usuarios anónimos.\n"
  83. ;;
  84. 210)
  85. type="WARNING"
  86. error="$type $codeNum:\tImposible eliminar bases de datos de pruebas.\n"
  87. ;;
  88. 211)
  89. type="WARNING"
  90. error="$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas.\n"
  91. ;;
  92. 212)
  93. error="$type $codeNum:\tImposible recargar base de datos.\n"
  94. ;;
  95. 300)
  96. error="$type $codeNum:\tError interno (instalación PHP).\n"
  97. ;;
  98. 301)
  99. error="$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  100. ;;
  101. 302)
  102. error="$type $codeNum:\tError al instalar PHP.\nDetalles:\n$extraInfo\n"
  103. ;;
  104. 303)
  105. error="$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  106. ;;
  107. 304)
  108. error="$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  109. ;;
  110. 800)
  111. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  112. ;;
  113. 801)
  114. error="$type $codeNum:\t'whiptail' no instalado.\n"
  115. ;;
  116. 802)
  117. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  118. ;;
  119. 803)
  120. error="$type $codeNum:\t'apt-get' no instalado.\n"
  121. ;;
  122. 804)
  123. error="$type $codeNum:\t'yum' no instalado.\n"
  124. ;;
  125. 805)
  126. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  127. ;;
  128. 806)
  129. error="$type $codeNum:\t'ufw' no instalado.\n"
  130. ;;
  131. 807)
  132. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  133. ;;
  134. 808)
  135. error="$type $codeNum:\t'tput' no instalado.\n"
  136. ;;
  137. 900)
  138. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  139. ;;
  140. 901)
  141. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  142. ;;
  143. 902)
  144. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  145. ;;
  146. *)
  147. error="ERROR 13:\tError interno (comprobación de errores)\n"
  148. exitNum=1
  149. codeNum=13
  150. ;;
  151. esac
  152. if [ $exitNum -ne 0 ];then
  153. printf "$error"
  154. if [ $type = "ERROR" ];then
  155. exit $codeNum
  156. fi
  157. fi
  158. unset error exitNum codeNum type
  159. }
  160. OSInfo() {
  161. #printf "Detectando SO..."
  162. OS=$(uname -s)
  163. if [ $OS = "Linux" ]; then
  164. OS="GNU/Linux"
  165. if [ -f /etc/os-release ]; then
  166. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  167. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  168. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  169. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  170. for i in $ID_LIKE; do
  171. #printf "$i\n"
  172. case $i in
  173. debian|ubuntu)
  174. debianOS=true
  175. break
  176. ;;
  177. rhel|fedora)
  178. rhelOS=true
  179. break
  180. ;;
  181. *)
  182. debianOS=false
  183. rhelOS=false
  184. ;;
  185. esac
  186. done
  187. elif [ -f /etc/debian-version ]; then
  188. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  189. DIST="Debian"
  190. REV=""
  191. ID_LIKE="debian"
  192. VERSION=""
  193. debianOS=true
  194. elif [ -f /etc/redhat-release ]; then
  195. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  196. DIST="Red-Hat"
  197. REV=""
  198. ID_LIKE="rhel"
  199. VERSION=""
  200. rhelOS=true
  201. else
  202. # Other Linux (No Soportado)
  203. DIST=""
  204. REV=""
  205. ID_LIKE=""
  206. VERSION=""
  207. fi
  208. else
  209. # UNIX, OS X, ... (No Soportado)
  210. DIST=$OS
  211. REV=""
  212. ID_LIKE=""
  213. VERSION=""
  214. fi
  215. #printf " $OS $DIST $REV\n"
  216. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  217. }
  218. comprobarRoot() {
  219. comprobarError $(id -u) 800
  220. }
  221. comprobarDependencias() {
  222. # Comprobamos whiptail
  223. which whiptail > /dev/null 2>&1
  224. comprobarError $? 801
  225. # Comprobamos hostnamectl
  226. which hostnamectl > /dev/null 2>&1
  227. comprobarError $? 802
  228. # Comprobamos tput
  229. which tput > /dev/null 2>&1
  230. comprobarError $? 808
  231. if [ $debianOS = true ];then
  232. # Comprobamos apt-get
  233. which apt-get > /dev/null 2>&1
  234. comprobarError $? 803
  235. # Actualizamos base de datos del repositorio
  236. printf "Actualizando repositorio APT..."
  237. result=$(apt-get -q -y update)
  238. comprobarError $? 805 $result
  239. printf " OK.\n"
  240. # Comprobamos Firewall (ufw)
  241. which ufw > /dev/null 2>&1
  242. comprobarError $? 806
  243. fi
  244. if [ $rhelOS = true ]; then
  245. # Comprobamos yum
  246. which yum > /dev/null 2>&1
  247. comprobarError $? 804
  248. # Actualizamos base de datos del repositorio
  249. printf "Actualizando repositorio YUM..."
  250. result=$(yum -y makecache 2>&1)
  251. comprobarError $? 805 $result
  252. printf " OK.\n"
  253. # Comprobamos Firewall (firewall-cmd)
  254. which firewall-cmd > /dev/null 2>&1
  255. comprobarError $? 807
  256. fi
  257. }
  258. inicializarVariables() {
  259. debianOS=false
  260. rhelOS=false
  261. apacheOn=false
  262. nginxOn=false
  263. mySQLOn=false
  264. mariaDBOn=false
  265. phpOn=false
  266. mediaWikiOn=false
  267. moodleOn=false
  268. actualizacionesOn=false
  269. progreso=0
  270. progresoTotal=0
  271. }
  272. instalacionExpress() {
  273. apacheOn=true
  274. mariaDBOn=true
  275. phpOn=true
  276. mediaWikiOn=true
  277. moodleOn=true
  278. actualizacionesOn=true
  279. progresoTotal=15
  280. # Preguntas mínimas
  281. establecerFQDN
  282. leerSQLPasswd
  283. }
  284. mostrarBienvenida() {
  285. ANCHO=$(tput cols)
  286. ALTO=$(tput lines)
  287. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  288. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  289. exit 1
  290. fi
  291. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  292. comprobarError $? 1
  293. }
  294. mostrarExpress() {
  295. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  296. "Express" "Instalación rápida" ON \
  297. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  298. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  299. comprobarError $? 1
  300. case $express in
  301. Express)
  302. instalacionExpress
  303. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  304. ;;
  305. Avanzada)
  306. mostrarAvanzada
  307. ;;
  308. *)
  309. comprobarError 1 2
  310. ;;
  311. esac
  312. }
  313. mostrarAvanzada() {
  314. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 6 \
  315. "LAMP" "Linux + Apache + MySQL/MariaDB + PHP" ON \
  316. "LEMP" "Linux + Nginx + MySQL/MariaDB + PHP" ON \
  317. # "WebServer" "Instalar servidor web http/https" ON \
  318. # "Database" "Instalar una base de datos SQL" ON \
  319. # "PHP" "Instala PHP7" ON \
  320. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  321. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  322. "Moodle" "Instalar campus virtual con Moodle" ON \
  323. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  324. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  325. comprobarError $? 1
  326. # Mejora: autodetección de componentes ya instalados
  327. for i in $componentes; do
  328. case $i in
  329. \"LAMP\")
  330. apacheOn=true
  331. establecerFQDN
  332. mostrarDatabase
  333. phpOn=true
  334. progresoTotal=$((progresoTotal + 6))
  335. ;;
  336. \"LEMP\")
  337. nginxOn=true
  338. establecerFQDN
  339. mostrarDatabase
  340. phpOn=true
  341. progresoTotal=$((progresoTotal + 6))
  342. ;;
  343. # \"WebServer\")
  344. # mostrarWebServer
  345. # progresoTotal=$((progresoTotal + 2))
  346. # ;;
  347. # \"Database\")
  348. # mostrarDatabase
  349. # progresoTotal=$((progresoTotal + 2))
  350. # ;;
  351. # \"PHP\")
  352. # phpOn=true
  353. # progresoTotal=$((progresoTotal + 2))
  354. # ;;
  355. \"SSL/TLS\")
  356. # 2 Opciones: Let's Encrypt o Autofirmado
  357. progresoTotal=$((progresoTotal + 2))
  358. ;;
  359. \"MediaWiki\")
  360. mediaWikiOn=true
  361. progresoTotal=$((progresoTotal + 2))
  362. ;;
  363. \"Moodle\")
  364. moodleOn=true
  365. progresoTotal=$((progresoTotal + 2))
  366. ;;
  367. \"Actualizaciones\")
  368. actualizacionesOn=true
  369. progresoTotal=$((progresoTotal + 1))
  370. ;;
  371. *)
  372. comprobarError 1 3
  373. ;;
  374. esac
  375. done
  376. progresoTotal=$((progresoTotal + 2))
  377. }
  378. mostrarWebServer() {
  379. # DEPRECATED
  380. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  381. "Apache" "Instalar el servidor web Apache2" ON \
  382. "Nginx" "Instalar el servidor web Nginx" OFF \
  383. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  384. comprobarError $? 1
  385. case $webServer in
  386. Apache)
  387. apacheOn=true
  388. ;;
  389. Nginx)
  390. nginxOn=true
  391. ;;
  392. *)
  393. comprobarError 1 100
  394. ;;
  395. esac
  396. # Otras opciones (FQDN)
  397. establecerFQDN
  398. }
  399. establecerFQDN() {
  400. while [ -z $hostname ]; do
  401. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  402. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  403. hostnamectl set-hostname $hostname
  404. else
  405. hostname=$(hostname)
  406. fi
  407. done
  408. #printf "\nHostname: $hostname\n"
  409. }
  410. instalarApache() {
  411. if [ $debianOS = true ];then
  412. result=$(apt-get -q -y install apache2 2>&1)
  413. comprobarError $? 101 $result
  414. elif [ $rhelOS = true ]; then
  415. result=$(yum -y install httpd 2>&1)
  416. comprobarError $? 101 $result
  417. else
  418. comprobarError 1 104
  419. fi
  420. }
  421. instalarNginx() {
  422. if [ $debianOS = true ];then
  423. result=$(apt-get -q -y install nginx 2>&1)
  424. comprobarError $? 102 $result
  425. elif [ $rhelOS = true ]; then
  426. # Hay que instalar primero otro repositorio
  427. result=$(yum -y install epel-release)
  428. comprobarError $? 103 $result
  429. result=$(yum -y install nginx 2>&1)
  430. comprobarError $? 102 $result
  431. else
  432. comprobarError 1 105
  433. fi
  434. }
  435. mostrarDatabase() {
  436. if [ $debianOS = true ]; then
  437. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  438. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  439. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  440. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  441. comprobarError $? 1
  442. case $database in
  443. MySQL)
  444. mySQLOn=true
  445. ;;
  446. MariaDB)
  447. mariaDBOn=true
  448. ;;
  449. *)
  450. comprobarError 1 200
  451. ;;
  452. esac
  453. elif [ $rhelOS = true ]; then
  454. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  455. comprobarError $? 1
  456. mariaDBOn=true
  457. else
  458. comprobarError 1 200
  459. fi
  460. # Otras opciones (contraseña)
  461. leerSQLPasswd
  462. }
  463. leerSQLPasswd() {
  464. control=false
  465. error=""
  466. # Leemos la contreseña (stdin) y confirmamos
  467. while [ $control = false ]; do
  468. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  469. comprobarError $? 1
  470. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  471. comprobarError $? 1
  472. #printf "SQL Password 1: $sqlPasswd\n"
  473. #printf "SQL Password 2: $sqlPasswd2\n"
  474. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  475. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  476. elif [ $sqlPasswd != $sqlPasswd2 ];then
  477. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  478. else
  479. control=true
  480. fi
  481. done
  482. #printf "SQL Password: $sqlPasswd\n"
  483. unset control error sqlPasswd2
  484. }
  485. establecerSQLPasswd() {
  486. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  487. # Mejora: ¿Si ya tiene una contraseña asignada?
  488. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  489. if [ $? -eq 0 ];then
  490. # Establecemos contraseña del usuario root
  491. mysql -e "UPDATE mysql.user SET Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" > /dev/null 2>&1
  492. comprobarError $? 207
  493. # Desactivamos acceso root desde el exterior (solo localhost)
  494. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" > /dev/null 2>&1
  495. comprobarError $? 208
  496. # Eliminamos todos los usuarios anónimos
  497. mysql -e "DELETE FROM mysql.user WHERE User=''" > /dev/null 2>&1
  498. comprobarError $? 209
  499. # Eliminamos bases de datos 'test'
  500. mysql -e "DROP DATABASE IF EXISTS test" > /dev/null 2>&1
  501. comprobarError $? 210
  502. # Eliminamos privilegios de la base de datos 'test'
  503. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" > /dev/null 2>&1
  504. comprobarError $? 211
  505. # Aplicamos los cambios
  506. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  507. comprobarError $? 212
  508. else
  509. comprobarError $? 206
  510. fi
  511. }
  512. instalarMySQL() {
  513. if [ $debianOS = true ];then
  514. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  515. comprobarError $? 201 $result
  516. elif [ $rhelOS = true ];then
  517. # MySQL no disponible en RHEL. 2 opciones:
  518. # 1) Instalar un repositorio adicional
  519. # 2) No instalar MySQL en distribuciones RHEL
  520. comprobarError 1 205
  521. else
  522. comprobarError 1 203
  523. fi
  524. }
  525. instalarMariaDB() {
  526. if [ $debianOS = true ];then
  527. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  528. comprobarError $? 202 $result
  529. elif [ $rhelOS = true ];then
  530. result=$(yum -y install mariadb-server mariadb 2>&1)
  531. comprobarError $? 202 $result
  532. else
  533. comprobarError 1 204
  534. fi
  535. }
  536. instalarPHP() {
  537. # Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
  538. if [ $debianOS = true ];then
  539. if [ $apacheOn = true ]; then
  540. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-mcrypt openssl 2>&1)
  541. comprobarError $? 302 $result
  542. elif [ $nginxOn = true ];then
  543. result=$(apt-get -q -y install php-fpm libapache2-mod-php php-mysql php-intl php-mbstring php-mcrypt openssl 2>&1)
  544. comprobarError $? 302 $result
  545. else
  546. comprobarError 1 301
  547. fi
  548. elif [ $rhelOS = true ];then
  549. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  550. result=$(yum -y install epel-release)
  551. comprobarError $? 103 $result
  552. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  553. if [ $VERSION = "7" ];then
  554. result=$(rpm -U http://rpms.famillecollet.com/enterprise/remi-release-7.rpm 2>&1)
  555. comprobarError $? 303 $result
  556. elif [ $VERSION = "6" ];then
  557. result=$(rpm -U http://rpms.famillecollet.com/enterprise/remi-release-6.rpm 2>&1)
  558. comprobarError $? 303 $result
  559. else
  560. comprobarError 1 304
  561. fi
  562. # Instalamos PHP-7.2
  563. if [ $apacheOn = true ];then
  564. result=$(yum -y install php72 php72-php-pecl-mysql php72-php-intl php72-php-mbstring php72-php-pecl-mcrypt openssl 2>&1)
  565. comprobarError 1 302 $result
  566. elif [ $nginxOn = true ];then
  567. result=$(yum -y install php72 php72-php-fpm php72-php-pecl-mysql php72-php-intl php72-php-mbstring php72-php-pecl-mcrypt openssl 2>&1)
  568. comprobarError $? 302 $result
  569. else
  570. comprobarError 1 301
  571. fi
  572. else
  573. comprobarError 1 300
  574. fi
  575. }
  576. habilitarServicio() {
  577. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  578. # Intentamos con systemctl (SystemD)
  579. printf "Habilitando servicio $1"
  580. if [ $# -le 0 ];then
  581. comprobarError 1 900
  582. fi
  583. which systemctl > /dev/null 2>&1
  584. if [ $? -eq 0 ]; then
  585. printf " (SystemD)..."
  586. systemctl start $1 > /dev/null 2>&1
  587. comprobarError $? 901 $1
  588. systemctl enable $1 > /dev/null 2>&1
  589. comprobarError $? 902 $1
  590. else
  591. # Intentamos con service (Upstart)
  592. which service > /dev/null 2>&1
  593. if [ $? -eq 0 ]; then
  594. printf " (Upstart)..."
  595. service $1 start > /dev/null 2>&1
  596. comprobarError $? 901 $1
  597. else
  598. # Intentamos con init.d (SystemV)
  599. printf " (SystemV)..."
  600. /etc/init.d/$1 start > /dev/null 2>&1
  601. comprobarError $? 901 $1
  602. fi
  603. # Intentamos habilitar en el arranque (Upstart)
  604. which update-rc.d > /dev/null 2>&1
  605. if [ $? -eq 0 ];then
  606. update-rc.d $1 enable
  607. comprobarError $? 902 $1
  608. else
  609. # Intentamos habilitar en el arranque (SystemV)
  610. which chkconfig > /dev/null 2>&1
  611. if [ $? -eq 0 ];then
  612. chkconfig $1 on
  613. comprobarError $? 902 $1
  614. else
  615. # ¿Qué mas opciones nos quedan?
  616. comprobarError 1 902 $1
  617. fi
  618. fi
  619. fi
  620. # Mejora: comprobar si el servicio está funcionando
  621. printf " OK.\n"
  622. }
  623. # Comprobación del sistema e inicialización
  624. comprobarRoot
  625. inicializarVariables
  626. OSInfo
  627. comprobarDependencias
  628. # Bienvenida
  629. mostrarBienvenida
  630. # Selección de componentes (express vs avanzada)
  631. mostrarExpress
  632. # Pre-configuración
  633. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  634. # Instalación
  635. # FALTA: whiptail --gauge -> Más bonito
  636. # Servidor Web
  637. if [ $apacheOn = true ]; then
  638. printf "Instalando Web Server Apache..."
  639. {
  640. printf "%s\n" $((100 * progreso / progresoTotal))
  641. instalarApache
  642. progreso=$((progreso + 1))
  643. } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  644. printf " OK.\n"
  645. elif [ $nginxOn = true ]; then
  646. printf "Instalando Web Server Nginx..."
  647. {
  648. printf "%s\n" $((100 * progreso / progresoTotal))
  649. instalarNginx
  650. progreso=$((progreso + 1))
  651. } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  652. printf " OK.\n"
  653. fi
  654. # Base de Datos
  655. if [ $mySQLOn = true ]; then
  656. printf "Instalando Base de Datos MySQL..."
  657. {
  658. printf "%s\n" $((100 * progreso / progresoTotal))
  659. instalarMySQL
  660. progreso=$((progreso + 1))
  661. } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  662. printf " OK.\n"
  663. elif [ $mariaDBOn = true ]; then
  664. printf "Instalando Base de Datos MariaDB..."
  665. {
  666. printf "%s\n" $((100 * progreso / progresoTotal))
  667. instalarMariaDB
  668. progreso=$((progreso + 1))
  669. } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  670. printf " OK.\n"
  671. fi
  672. # PHP
  673. if [ $phpOn = true ]; then
  674. printf "Instalando PHP-7..."
  675. {
  676. printf "%s\n" $((100 * progreso / progresoTotal))
  677. instalarPHP
  678. progreso=$((progreso + 1))
  679. } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  680. printf " OK.\n"
  681. fi
  682. # SSL/TLS
  683. # Falta por implementar
  684. {
  685. printf "%s\n" $((100 * progreso / progresoTotal))
  686. sleep 2
  687. progreso=$((progreso + 1))
  688. } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  689. # MediaWiki
  690. if [ $mediaWikiOn = true ]; then
  691. printf "Instalando MediaWiki..."
  692. {
  693. printf "%s\n" $((100 * progreso / progresoTotal))
  694. sleep 2
  695. progreso=$((progreso + 1))
  696. } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  697. printf " OK.\n"
  698. fi
  699. # Moodle
  700. if [ $moodleOn = true ]; then
  701. printf "Instalando Moodle..."
  702. {
  703. printf "%s\n" $((100 * progreso / progresoTotal))
  704. sleep 2
  705. progreso=$((progreso + 1))
  706. } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  707. printf " OK.\n"
  708. fi
  709. # PRECAUCION!!!! Hay que habilitar algunos servicios antes de configurarlos
  710. # Por ejemplo: para cambiar la contraseña de root en mysql
  711. # Configuración
  712. # Configuración Apache
  713. # Virtual Hosts
  714. printf "Configurando Servidor Web..."
  715. {
  716. printf "%s\n" $((100 * progreso / progresoTotal))
  717. sleep 2
  718. progreso=$((progreso + 1))
  719. } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  720. printf " OK.\n"
  721. # Configuración Database
  722. # Arrancar Base de Datos, establecer contraseña y configuración segura
  723. if [ $mySQLOn = true ];then
  724. printf "Configurando Base de Datos MySQL..."
  725. {
  726. printf "%s\n" $((100 * progreso / progresoTotal))
  727. habilitarServicio mysql
  728. establecerSQLPasswd
  729. progreso=$((progreso + 1))
  730. } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  731. printf " OK.\n"
  732. fi
  733. if [ $mariaDBOn = true ];then
  734. printf "Configurando Base de Datos MAriaDB..."
  735. {
  736. printf "%s\n" $((100 * progreso / progresoTotal))
  737. habilitarServicio mariadb
  738. establecerSQLPasswd
  739. progreso=$((progreso + 1))
  740. } > >(whiptail --gauge "Configurando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  741. printf " OK.\n"
  742. fi
  743. # Configuración PHP
  744. # cgi.fix_pathinfo=0
  745. # Configurar máximo de subida de archivos
  746. printf "Configurando PHP-7..."
  747. {
  748. printf "%s\n" $((100 * progreso / progresoTotal))
  749. sleep 2
  750. progreso=$((progreso + 1))
  751. } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  752. printf " OK.\n"
  753. # Configuración MediWiki
  754. printf "Configurando MediaWiki..."
  755. {
  756. printf "%s\n" $((100 * progreso / progresoTotal))
  757. sleep 2
  758. progreso=$((progreso + 1))
  759. } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  760. printf " OK.\n"
  761. # Configuración Moodle
  762. printf "Configurando Moodle..."
  763. {
  764. printf "%s\n" $((100 * progreso / progresoTotal))
  765. sleep 2
  766. progreso=$((progreso + 1))
  767. } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  768. printf " OK.\n"
  769. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  770. printf "Arrancando Servicios..."
  771. {
  772. printf "%s\n" $((100 * progreso / progresoTotal))
  773. sleep 2
  774. progreso=$((progreso + 1))
  775. } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  776. printf " OK.\n"
  777. # Añadir reglas del cortafuegos
  778. printf "Configurando Cortafuegos..."
  779. {
  780. printf "%s\n" $((100 * progreso / progresoTotal))
  781. sleep 2
  782. progreso=$((progreso + 1))
  783. } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  784. printf " OK.\n"
  785. # Configuración SSL/TLS
  786. # Generar certificados
  787. # Configurar certificados
  788. printf "Configurando SSL/TLS..."
  789. {
  790. printf "%s\n" $((100 * progreso / progresoTotal))
  791. sleep 2
  792. progreso=$((progreso + 1))
  793. } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  794. printf " OK.\n"
  795. # Configurar actualizaciones
  796. if [ $actualizacionesOn = true ]; then
  797. printf "Configurando actualizaciones automáticas..."
  798. {
  799. printf "%s\n" $((100 * progreso / progresoTotal))
  800. sleep 2
  801. progreso=$((progreso + 1))
  802. } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  803. printf " OK.\n"
  804. fi